package com.openhis.web.materialmanage.appservice.impl;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.stream.Collectors;

import javax.annotation.Resource;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.core.common.core.domain.R;
import com.core.common.utils.AssignSeqUtil;
import com.core.common.utils.DateUtils;
import com.core.common.utils.MessageUtils;
import com.openhis.common.constant.CommonConstants;
import com.openhis.common.constant.PromptMsgConstant;
import com.openhis.common.enums.*;
import com.openhis.common.utils.EnumUtils;
import com.openhis.web.inventorymanage.dto.ProductStocktakingInitDto;
import com.openhis.web.materialmanage.appservice.IMaterialCommonService;
import com.openhis.web.materialmanage.appservice.IMaterialReturnOrderService;
import com.openhis.web.materialmanage.dto.MaterialDetailDto;
import com.openhis.web.materialmanage.dto.MaterialInitDto;
import com.openhis.web.materialmanage.mapper.MaterialCommonMapper;
import com.openhis.workflow.domain.SupplyRequest;
import com.openhis.workflow.service.ISupplyRequestService;

/**
 * 物资退货单
 *
 * @author yuxj
 * @date 2025-07-22
 */
@Service
public class MaterialReturnOrderServiceImpl implements IMaterialReturnOrderService {

    @Resource
    private AssignSeqUtil assignSeqUtil;
    @Resource
    private ISupplyRequestService supplyRequestService;
    @Autowired
    private IMaterialCommonService materialCommonService;
    @Autowired
    private MaterialCommonMapper materialCommonMapper;

    /**
     * 初始化
     *
     * @return 初始化信息
     */
    @Override
    public R<?> init() {

        MaterialInitDto purchaseOrderInitDto = materialCommonService.init();

        // 单据分类
        List<MaterialInitDto.IntegerOption> supplyCategoryOption = new ArrayList<>();
        // supplyCategoryOption.add(new MaterialInitDto.IntegerOption(SupplyCategory.NORMAL.getValue(),
        // SupplyCategory.NORMAL.getInfo()));

        purchaseOrderInitDto.setSupplyCategoryOptions(supplyCategoryOption);

        return R.ok(purchaseOrderInitDto);
    }

    /**
     * 退货单单据详情
     *
     * @param busNo 单据号
     * @param pageNo 当前页码
     * @param pageSize 查询条数
     * @return 退货单单据详情
     */
    @Override
    public R<?> getDetailPage(String busNo, Integer pageNo, Integer pageSize) {

        Page<MaterialDetailDto> returnOrderDtoDetailPage =
            materialCommonMapper.getDetailPage(new Page<>(pageNo, pageSize), busNo);

        returnOrderDtoDetailPage.getRecords().forEach(e -> {
            // 单据分类
            e.setCategoryEnum_enumText(EnumUtils.getInfoByValue(SupplyCategory.class, e.getCategoryEnum()));
            // 单据状态
            e.setStatusEnum_enumText(EnumUtils.getInfoByValue(SupplyStatus.class, e.getStatusEnum()));
            // 单据类型
            e.setTypeEnum_enumText(EnumUtils.getInfoByValue(SupplyType.class, e.getTypeEnum()));
        });

        List<MaterialDetailDto.Option> unitList;
        for (MaterialDetailDto item : returnOrderDtoDetailPage.getRecords()) {
            unitList = new ArrayList<>();
            unitList.add(new MaterialDetailDto.Option(item.getMaxUnitCode(), item.getMaxUnitCode_dictText()));
            unitList.add(new MaterialDetailDto.Option(item.getMinUnitCode(), item.getMinUnitCode_dictText()));

            item.setUnitList(unitList);
        }

        return R.ok(returnOrderDtoDetailPage);
    }

    /**
     * 获取单据号
     *
     * @return 初始化信息
     */
    @Override
    public R<?> getBusNo() {

        ProductStocktakingInitDto initDto = new ProductStocktakingInitDto();
        // 单据号
        initDto.setBusNo(assignSeqUtil.getSeqByDay(AssignSeqEnum.MATERIAL_RETURN.getPrefix(), 4));

        return R.ok(initDto);
    }

    /**
     * 添加/编辑退货单
     *
     * @param returnOrderDtoList 退货信息
     * @return 操作结果
     */

    @Override
    public R<?> addOrEditReturnOrder(List<MaterialDetailDto> returnOrderDtoList) {
        // 请求数据取得
        List<SupplyRequest> requestList = supplyRequestService.getSupplyByBusNo(returnOrderDtoList.get(0).getBusNo());
        if (!requestList.isEmpty()) {
            // 请求id取得
            List<Long> requestIdList = requestList.stream().map(SupplyRequest::getId).collect(Collectors.toList());
            // 单据信息删除
            supplyRequestService.removeByIds(requestIdList);
        }
        // 添加原始单据号
        if (returnOrderDtoList.get(0).getOriginalBusNo() != null) {
            // 审批单据并返回单据详情
            List<SupplyRequest> agreedList = supplyRequestService
                .addOriginalBusNo(returnOrderDtoList.get(0).getOriginalBusNo(), returnOrderDtoList.get(0).getBusNo());
            if (agreedList.isEmpty()) {
                return R.fail(MessageUtils.createMessage(PromptMsgConstant.Common.M00007, null));
            }
        }

        List<SupplyRequest> supplyRequestList = new ArrayList<>();
        Date applyTime = DateUtils.getNowDate();
        for (MaterialDetailDto item : returnOrderDtoList) {
            SupplyRequest supplyRequest =
                new SupplyRequest().setBusNo(item.getBusNo()).setTypeEnum(SupplyType.MATERIAL_RETURN.getValue())
                    .setStatusEnum(SupplyStatus.PENDING_REVIEW.getValue()).setCategoryEnum(item.getCategoryEnum())
                    .setItemTable(CommonConstants.TableName.ADM_DEVICE_DEFINITION).setItemId(item.getItemId())
                    .setUnitCode(item.getUnitCode()).setItemQuantity(item.getItemQuantity()).setPrice(item.getPrice())
                    .setTotalPrice(item.getTotalPrice()).setRetailPrice(item.getRetailPrice())
                    .setTotalRetailPrice(item.getTotalRetailPrice()).setBatchInventory(item.getBatchInventory())
                    .setOccurrenceTime(item.getOccurrenceTime()).setEndTime(item.getEndTime())
                    .setLotNumber(item.getLotNumber()).setInvoiceNo(item.getInvoiceNo()).setTraceNo(item.getTraceNo())
                    .setTraceNoUnitCode(item.getTraceNoUnitCode()).setSupplierId(item.getSupplierId())
                    .setReason(item.getReason()).setSourceTypeEnum(LocationForm.WAREHOUSE.getValue())
                    .setSourceLocationId(item.getSourceLocationId()).setApplicantId(item.getApplicantId())
                    .setApplyTime(applyTime).setRemake(item.getRemake());
            supplyRequestList.add(supplyRequest);
        }
        // 更新请求表
        boolean flg = supplyRequestService.saveOrUpdateBatch(supplyRequestList);
        if (!flg) {
            return R.fail(MessageUtils.createMessage(PromptMsgConstant.Common.M00011, null));
        }

        return R.ok(MessageUtils.createMessage(PromptMsgConstant.Common.M00004, null));
    }

}
